#include <WiFi.h>

const char* ssid = "ESP32-AP";
const char* password = "12345678"; // minimum length 8 required

WiFiServer server(80);
String html ="<!DOCTYPE html> \
<html> \
<body> \
<center><h1>ESP32 Access Point </h1></center> \
<center><h2>Web Server to manage built-in led</h2></center> \
<form> \
<button name=\"LED\" button style=\"color:green\" value=\"ON\" type=\"submit\">LED ON</button> \
<button name=\"LED\" button style=\"color=red\" value=\"OFF\" type=\"submit\">LED OFF</button><br><br> \
</form> \
</body> \
</html>";


void setup(){
  Serial.begin(115200);
  pinMode(LED_BUILTIN, OUTPUT);
  digitalWrite(LED_BUILTIN, LOW);

  Serial.print("Setting soft access point mode");
  WiFi.mode(WIFI_AP); // change mode to Access Point
  WiFi.softAP(ssid, password); 
  IPAddress IP = WiFi.softAPIP(); 
  Serial.print("AP IP address: "); // Default IP is 192.168.4.1
  Serial.println(IP);
  
  server.begin(); // lanuch web server
}


void loop(){
  WiFiClient client=server.available();
  if(client){
    String request = client.readStringUntil('\r');
    if(request.indexOf("LED=ON") != -1)
      digitalWrite(LED_BUILTIN, HIGH);
    if(request.indexOf("LED=OFF") != -1)
      digitalWrite(LED_BUILTIN, LOW);
    client.print(html);
    request="";
  }
}
