/*
 * PhidgetsP5 -> Démonstration Phidgets
 * v. 1.0
 * 
 * (c) Ph. Truillet, Oct. 2014
 * Last Revision: 21/10/2014
 */

// phidgets
import com.phidgets.*;
import com.phidgets.event.*;


// data
String date;
PImage img;
PFont f1, f2,f3;

InterfaceKitPhidget ik;

int mySensorCount;
int[] analogVals = new int[8];
String rfidvalue = "";

String temperature;
String voltage;
boolean allume = false;
Check c1;

/*
0 :capteur de présence
1 : capteur de luminosité
2 : capteur voltaïque     voltage = (sensor_value * 0.06) - 
3 : capteur température
*/

void setup()
{
  //size(displayWidth,displayHeight);
  size(800,600);
  background(0);
  f1 = loadFont("SketchNice-48.vlw");
  f2 = loadFont("Courier16.vlw");
  f3 = loadFont("Courier12.vlw");
  
  try
  { 
    ik = new InterfaceKitPhidget();
    
    // connect to InterfaceKit
    ik.openAny();
    ik.waitForAttachment(); 
    print("Found: ");
    println(ik.getDeviceName());
    // add sensor listener
    ik.addSensorChangeListener(new SensorChangeListener() 
    {
      public void sensorChanged(SensorChangeEvent se)
      {
        // we store the value in the appropriate array
        analogVals[se.getIndex()] = se.getValue();
        // println("sensor " + se.getIndex() + " value => " + se.getValue() );
      }
     });       
   
   // init sensor values 
    mySensorCount = ik.getSensorCount();
    ik.setRatiometric(false);
    for (int i=0;i<mySensorCount;i++)
      analogVals[i]=ik.getSensorValue(i);
 
  }
  catch(Exception e)
  {
    println("Error Phidget");
  }
  frameRate(10);
  
  c1 = new Check(160,565,20, color(128)); 
}


void draw()
{
  // Dessiner l'interface
  background(0);
  textFont(f1,48);
  textAlign(LEFT);
  fill(255);
  text("Maison connectée", 140,50);
    
  
  // Sensors
  // lire les valeurs 0 (présence), 1 (luminosité),, 3 (température ambiante)
  textFont(f1, 24);
  textAlign(LEFT);
  text("Capteurs", 40,150);
  textFont(f2, 16);
  text("Présence : ", 70, 200);
  // motion sensor : 500 -> no motion
  fill(map(abs(500-analogVals[0]),0,200,0,255),255-map(abs(500-analogVals[0]),0,200,0,255),0);
  rect(210, 175, 50, 50, 3, 6, 12, 18);
  
  fill(255);
  text("Luminosité : ", 70, 280);
  fill(map(analogVals[1],0,1000,0,255));
  rect(210, 255, 50, 50, 3, 6, 12, 18);
  
  // température
  fill(255);
  text("Température : ", 70, 360);
  // Temperature (°C) = (SensorValue/4) - 50
  temperature = " " + ((analogVals[3]/4)-50) + " °C";
  text(temperature, 200,360);
  
  
  // Lumière
  textFont(f1, 24);
  textAlign(LEFT);
  text("Lumière", 40,530);  
  
  textFont(f2, 16); 
  c1.display();
  allume = c1.getState();
  try
  {
    ik.setOutputState(7, allume);
  }
  catch (Exception e) {}
  
  if (allume==false)
    text("Eteinte ", 70, 580); 
  else
     text("Allumée ", 70, 580); 
}


void mousePressed()
{
  c1.press(mouseX,mouseY);
}


void stop()
{
  try
  {
    ik.close();
  }
  catch(Exception e)
  {
  }
}
