/********************** 
 * QR Code recogniser
 * detects QRCodes and displays results
 * 
 */
 
import processing.video.*;
import com.google.zxing.*;
import java.awt.image.BufferedImage;

Capture cam;
com.google.zxing.Reader reader = new com.google.zxing.MultiFormatReader();
String url="";

void setup() {
 size(640, 550);
 background(0);
 PFont myFont;
 myFont = loadFont("Myriad.vlw");
 textFont(myFont, 14);
 
 cam = new Capture(this, 640, 480);
 cam.start(); // démarrer la caméra
}


void draw() {
 if (cam.available() == true) 
 {
   cam.read();    
   image(cam, 0, 0);
   try
   {
     LuminanceSource source = new BufferedImageLuminanceSource((BufferedImage)cam.getImage());
     BinaryBitmap bitmap = new BinaryBitmap(new HybridBinarizer(source));    
     Result result = reader.decode(bitmap); 
     if (result.getText() != null) 
     { 
       fill(#000000);
       rect(0,480,640,70);
       fill(#ffffff);
       
       /* is it an url? */
       String[] m = match(result.getText(),"http");
       if (m != null) 
         url = result.getText();
       else
         url ="";
         
       text(result.getText(),10,500);
       
       ResultPoint[] points = result.getResultPoints();
       // calcul du centre de gravité 
       /*
       float xg = 0;
       float yg = 0;
       for (int i = 0; i < points.length; i++)
       {
         xg = xg + points[i].getX();
         yg = yg + points[i].getY();
       } 
       noFill();
       ellipse(xg/4,yg/4, 160,160);
       */
       // Draw triangle and some ellipses on at the control points
       noFill();
       triangle(points[0].getX(),points[0].getY(),points[1].getX(),points[1].getY(),points[2].getX(),points[2].getY());
       
       for (int i = 0; i < points.length; i++) 
       {
         fill(#e88b10);
         ellipse(points[i].getX(), points[i].getY(), 20,20);
         fill(#0c075a);
         text(i, points[i].getX(), points[i].getY());
       }
       
     }
   } 
   catch (Exception e) 
   {
     // println(e.toString()); 
   }   
 }
}

void mousePressed()
{
  if (url != "")
    link(url);
}
