<img src="https://github.com/truillet/international/blob/master/utt/code/utt.png" width=150>
<h1>IF37 - Conception de Systèmes Interactifs</h1>

# Supports de cours

## Séance 1
* **Cours 1** : [IHM : un survol](https://github.com/truillet/international/blob/master/utt/supports/survol_ihm_3_92.pdf) (2022)
* **Cours1b** : [Inclusivité](https://github.com/truillet/international/blob/master/utt/supports/Handicap.pdf) (2022)
* **TP1** : [Accessibilité & Handicap](https://github.com/truillet/international/blob/master/utt/supports/TP1_Accessibilite_et_Handicap.pdf) (2022)

### Quelques articles "à lire" ou "écouter"
* [Les cours IHM au Collège de France de Wendy Mackay](https://www.college-de-france.fr/site/wendy-mackay/_agenda.htm)
* [The Augmentation of Douglas Engelbart](https://www.youtube.com/watch?v=_7ZtISeGyCY)

[<img src="https://img.youtube.com/vi/_7ZtISeGyCY/0.jpg" width=250 alt="Put That There">](https://www.youtube.com/watch?v=_7ZtISeGyCY)

* [The Information Capacity of he Human Motor System in Controlling The Amplitude of Movement](https://github.com/truillet/upssitech/blob/master/SRI/1A/articles/Fitts_1954.pdf), Paul Fitts in Journal of Experimental Psychology, vol. 47, No 6, June 1954
* [50 ans d'interaction homme-machine](https://interstices.info/50-ans-dinteraction-homme-machine-retours-vers-le-futur/)
* [ACM Interactions Magazine](http://interactions.acm.org)

### Liens logiciels
* [color blindness](https://www.color-blindness.com/coblis-color-blindness-simulator)
* [NVDA - Non Visual Desktop Access](https://www.nvda-fr.org)

## Séance 2
* **Cours2** : [Conception & Prototypage](https://github.com/truillet/international/blob/master/utt/supports/Conception_Prototypage.pdf) (2022)
* **Cours2b** : [Introduction à Processing](https://github.com/truillet/international/blob/master/utt/supports/introduction_processing.pdf) (2022)
* **Cours2c** : [Un middleware pour l'interaction](https://github.com/truillet/international/blob/master/utt/supports/C_ivy_2.6.pdf) (2022)

* **TP2** : [Initiation à Processing.org](https://github.com/truillet/international/blob/master/utt/supports/TP2_UTT_processing.pdf) (2022)

### Articles à lire
* [Reimagining Participatory Design](http://interactions.acm.org/archive/view/january-february-2019/reimagining-participatory-design), ACM Interactions, January-February 2019, p.26
* [Chaine Youtube "The Coding Train"](https://www.youtube.com/thecodingtrain)

### Liens logiciels
* [Processing.org](https://processing.org)
* [p5js](https://p5js.org)

## Séance 3
   * **Cours/TP3** : [Prototypage Physique, un peu d'arduino](https://github.com/truillet/international/blob/master/utt/supports/arduino_UTT.pdf)
   * **Cours** : [Introduction au Raspberry Pi](https://github.com/truillet/international/blob/master/utt/supports/Introduction_RPi.pdf)
 
 **Code**
 * [Exercices de base](https://github.com/truillet/international/blob/master/utt/code/base_arduino.zip)
 * [DHT - capteur de température et d'humidité](https://github.com/truillet/international/blob/master/utt/code/DHT_ESP32.zip)
 * [neopixel - des leds multicolores](https://github.com/truillet/international/blob/master/utt/code/neopixel_ESP32.zip)
 * [Near Field Communication - un capteur NFC](https://github.com/truillet/international/blob/master/utt/code/NFC_ESP32.zip)
 * [Point d'accès WiFi](https://github.com/truillet/international/blob/master/utt/code/AcessPoint_ESP32.zip)
 * [Exemple de liaison série processing/Arduino](https://github.com/truillet/international/blob/master/utt/code/processing_arduino.zip)
 
 Suivant le matériel utilisé, vous serez amenés à utiliser le driver [CH341SER](https://github.com/HobbyComponents/CH340-Drivers/tree/master/CH341SER) [notamment pour les clones chinois] ou le driver [CP210x USB to UART Bridge](https://www.silabs.com/developers/usb-to-uart-bridge-vcp-drivers), utile pour les ESP32 par exemple
 
## Séance 4
 * **Cours4** : [Vers le multimodal, un peu de parole](https://github.com/truillet/international/blob/master/utt/supports/I_V(IO)_Master_2_8.pdf)

## Séance 5
* **Cours5** : [ivy : un bus logiciel au service du prototypage avancé](https://github.com/truillet/ivy/blob/master/doc/C_ivy_2.5.pdf) et [Github ivy](https://github.com/truillet/ivy)

 * **TP4** - [Interaction vocale](https://github.com/truillet/international/blob/master/utt/supports/TP4_interaction_vocale.pdf) (2022)

 **Les outils utilisés dans le TP** : 
 * **Les outils utilisés dans le TP** : Agent de reconnaissance vocale / Speech Recognizer agent [sra5](https://github.com/truillet/ivy/blob/master/agents/sra5.zip), agent de synthèse vocale / speech Synthesis agent [ppilot5 v 3.3](https://github.com/truillet/ivy/blob/master/agents/ppilot5_3.3.zip), outil de supervision ivy / ivy monitoring tool [Probe](https://github.com/truillet/ivy/blob/master/code/Probe.zip) ou / or [visionneur](https://github.com/truillet/upssitech/blob/master/SRI/3A/IHM/TP/Outils/visionneur_1_2.zip)
  * **[GrXML pour SAPI 5](https://github.com/truillet/upssitech/blob/master/SRI/3A/IHM/Memo/GrXML.pdf)**
  * **[SSML pour SAPI 5](https://github.com/truillet/upssitech/blob/master/SRI/3A/IHM/Memo/ssml.pdf)**

_Exemple de code Processing permettant la reconnaissance vocale avec Google Chrome_ : **[RecoChrome](https://github.com/truillet/international/blob/master/utt/code/RecoChrome.zip)**

_Exemple de code Processing permettant l'affichage de la reconnaissance vocale et l'envoi du résultat vers la synthèse vocale : **[vocal_ivy](https://github.com/truillet/upssitech/blob/master/SRI/3A/IHM/TP/Code/vocal_ivy.zip)**

## Séance 6
* **Cours6** : [Vers le multimodal, un peu de geste](https://github.com/truillet/international/blob/master/utt/supports/Interaction_Gestuelle.pdf)

 * **TP5** - [Interaction gestuelle](https://github.com/truillet/international/blob/master/utt/supports/TP5_InteractionGestuelle.pdf) (2022)

_Exemple de code Processing permettant la gestion de formes géométriques_ : **[Palette](https://github.com/truillet/upssitech/blob/master/SRI/3A/IHM/TP/Code/Palette.zip)**

**Des systèmes de reconnaissance de gestes**
* **OneDollarIvy** (implémentation de l'algorithme du [$1 Recognizer](http://faculty.washington.edu/wobbrock/pubs/uist-07.01.pdf)) [code source](https://github.com/truillet/OneDollarIvy)
* **ICAR** (implémentation de l'algorithme de [Rubine](http://reports-archive.adm.cs.cmu.edu/anon/itc/CMU-ITC-099.pdf)) [code source](https://github.com/truillet/icar), [fichier jar](https://github.com/truillet/upssitech/blob/master/SRI/3A/IHM/TP/Outils/icar.1.2.zip) et [documentation](https://github.com/truillet/upssitech/blob/master/SRI/3A/IHM/TP/Outils/icar.pdf)
* [**IcarP5**](https://github.com/truillet/international/blob/master/utt/code/IcarP5.zip) (Intégration avec Processing.org d'ICAR)
* **[$N Recognizer](https://depts.washington.edu/acelab/proj/dollar/ndollar.html)**

 
## Quelques liens à lire / parcourir
* [M. Beaudoin-Lafon, 50 ans d'interaction homme-machine : retours vers le futur, Interstices.info](https://interstices.info/50-ans-dinteraction-homme-machine-retours-vers-le-futur)
* [Microsoft, Human-Computer Interaction in the Year 2020](https://www.microsoft.com/en-us/research/project/being-human/#:~:text=Human%2DComputer%20Interaction%20in%20the%20Year%202020&text=As%20we%20move%20further%20the,enables%20and%20recognizes%20human%20values.)
* [Reimagining Participatory Design](http://interactions.acm.org/archive/view/january-february-2019/reimagining-participatory-design), ACM Interactions, January-February 2019, p.26
* [ACM Interactions Magazine](http://interactions.acm.org)
* [<img src="https://img.youtube.com/vi/RyBEUyEtxQo/0.jpg" width=250 alt="Put That There">](https://youtu.be/RyBEUyEtxQo)
* [R. Bolt, "Put-That-There": Voice and Gesture at the Graphics Interface, SIGGRAPH 1980](https://www.media.mit.edu/speech/papers/1980/bolt_SIGGRAPH80_put-that-there.pdf)
* [Sh. Oviatt, Ten Myths on Multimodal Interaction, Communication of the ACM, volume 42, Issue 11, November 1999](https://dl.acm.org/doi/10.1145/319382.319398)


## Liens utiles
* [Processing in Java](https://happycoding.io/tutorials/java/processing-in-java) : configurer Eclipse pour Processing
* [Processing in Java](https://github.com/ctruillet/ProcessingOnIntellijIDEA) : configurer IntelliJ IDEA pour Processing
* [FlatIcons](https://flaticons.net) : des icônes libres de droit 
* [Adobe Color](https://color.adobe.com/fr/create) : Roue chromatique
